<?php
/**
 * panbb_ext_man_loader: database and output
 * @copyright (C) 2014-2015 PanBB
 * @license http://panbb.ru GPL
 * @package panbb_ext_man_loader
 * ///+++ RULES +++///
 * http://panbb.ru.
 */
 
if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', '../../');
require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'include/common_admin.php';

if ($forum_user['g_id'] != FORUM_ADMIN)
	message($lang_common['No permission']);
	
if (isset($_POST['load_ext']))
{
   
	$ext_dir = 'extensions/';
	$base_ext_url = FORUM_ROOT . $ext_dir . basename($_FILES['userfile']['name']);
	$full_ext_url = str_replace("../..", $base_url, $base_ext_url);
	$load_ext_name = $_FILES['userfile']['name'];
	
    if($_FILES['userfile']['size'] > 500000) {
        $message = "Размер файла превышает 500 кбайт";
        
    } else if ($_FILES['userfile']['type'] != 'application/x-compressed') {
        $message = 'Необходимо выбрать ZIP архив!';
        
    } else {
        
        if (move_uploaded_file($_FILES['userfile']['tmp_name'], $base_ext_url)) 
		{
			if (file_exists( $base_ext_url ))
			{
                    $curl = curl_init( $full_ext_url );
                    $fp = fopen( $load_ext_name, 'w' );
                    curl_setopt( $curl, CURLOPT_FILE, $fp );
                    curl_setopt( $curl, CURLOPT_HEADER, 0 );
                    curl_exec( $curl );
                    curl_close( $curl );
                    fclose( $fp );
                    
                    $zip = new ZipArchive;
                    if ($zip->open( $load_ext_name ) === TRUE)
                    {
                        $zip->extractTo( FORUM_ROOT . $ext_dir );
                        $zip->close();
						
                        if (file_exists( $load_ext_name ) === TRUE)
                        {
                            $link_ext_archive = $load_ext_name;
                            unlink( $link_ext_archive );
                        } 
                        //добавить проверку на манифест, затем вывести сообщение
						
						$message = ' Архив '.$load_ext_name.' загружен и распакован.';
                    } 

			}
			
        } else {
            $message = " Не удалось загрузить расширение! ";
        }
    }

	// Add flash message
	$forum_flash->add_info($message);
	redirect(forum_link($forum_url['panbb_ext_man_loader']), $message);

}

if (isset($_POST['del_ext']))
{
    $archive_name = forum_trim($_POST['ext_name']);
	$base_ext_url = FORUM_ROOT . 'extensions/';
	
    if (file_exists( $base_ext_url . $archive_name ) === TRUE)
    {
        unlink( $base_ext_url . $archive_name );
		$message = ' Архив '.$archive_name.' удален.';
    } 
    
	$forum_flash->add_info($message);
	redirect(forum_link($forum_url['panbb_ext_man_loader']), $message);  
}
	
// Load the admin.php language files
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_ext.php';

if (file_exists(FORUM_ROOT.'extensions/panbb_ext_man_loader/lang/'.$forum_user['language'].'.php'))
	require FORUM_ROOT.'extensions/panbb_ext_man_loader/lang/'.$forum_user['language'].'.php';
else
	require FORUM_ROOT.'extensions/panbb_ext_man_loader/lang/English.php';
	
$forum_page['crumbs'] = array(
    array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
	array($lang_admin_common['Extensions'], forum_link($forum_url['admin_extensions_manage'])),
	array('Загрузка', forum_link($forum_url['panbb_ext_man_loader']))
);

define('FORUM_PAGE_SECTION', 'extensions');
define('FORUM_PAGE', 'admin-ext-men-loader');
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();
?>

<div class="main-content main-frm">

	<div class="content-head">
		 <h2 class="hn"><span><?php echo $lang_ext_man_loader['Load_Extensions'] ?></h2>
	</div>

     <form class="frm-form" name="upload" action="<?php echo forum_link($forum_url['panbb_ext_man_loader']) ?>" method="POST" ENCTYPE="multipart/form-data">
		<div class="hidden">
			<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['panbb_ext_man_loader'])) ?>" />
			<input type="hidden" name="load_ext" value="1" />
		</div>
			
		<fieldset class="frm-group group<?php echo ++$forum_page['group_count'] ?>">
			<legend class="group-legend"><strong><?php echo 'EXT' ?></strong></legend>
			<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="sf-box text required">
					<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_ext_man_loader['Add_Archive'] ?></span><small><?php echo $lang_ext_man_loader['Select_Zip_For_Upload'] ?></small></label><br />
					<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" name="userfile" type="file" size="40" /></span>
				</div>
			</div>
		</fieldset>

		<div class="frm-buttons">
			<span class="submit primary"><input type="submit" name="load_ext" value="<?php echo $lang_ext_man_loader['Upload_Extension'] ?>" /></span>
		</div>
	</form>
		
		

	<div class="main-subhead">
		<h2 class="hn"><span><?php echo $lang_ext_man_loader['Load_Archive_Extensions'] ?></span></h2>
	</div>
	<div class="main-content main-frm">
		<div class="ct-group">
			<table>
				<thead>
					<tr>
						<th style="width:40%;"><?php echo $lang_ext_man_loader['Archive'] ?></th>
						<th style="width:20%;"><?php echo $lang_ext_man_loader['State'] ?></th>
						<th style="width:15%;"><?php echo $lang_ext_man_loader['Installed'] ?></th>
						<th style="width:10%;"><?php echo $lang_ext_man_loader['Size'] ?></th>
						<th style="width:10%;"><?php echo $lang_ext_man_loader['Actions'] ?></th>
					</tr>
				</thead>
				<tbody>
<?php
	$query = array(
		'SELECT'	=> 'e.id',
		'FROM'		=> 'extensions AS e',
		'WHERE'		=> 'e.disabled=0'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	$installed_ext = array();
	while ($row = $forum_db->fetch_assoc($result))
		$installed_ext[] = $row['id'];
		
	$glob_dir_ext = glob(FORUM_ROOT.'extensions/*.zip');

	foreach($glob_dir_ext as $link_ext_archive)
	{
?>

<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['panbb_ext_man_loader']) ?>">
		<div class="hidden">
			<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['panbb_ext_man_loader'])) ?>" />
			<input type="hidden" name="del_ext" value="1" />
		</div>
		
    	<tr >
    	    <input type="hidden" value="<?php echo str_replace("../../extensions/", '', $link_ext_archive); ?>" name="ext_name" />

			<?php $ext_archive = str_replace("../../extensions/", '', $link_ext_archive); ?>
			<td class="tc0"><strong><?php echo $ext_archive; ?></strong></td>
			<td class="tc1"><?php if(is_dir( $link_ext_dir )) echo $lang_ext_man_loader['Unpacked']; else echo $lang_ext_man_loader['Not_Unpacked']; ?></td>
			<?php $ext_name = str_replace(".zip", '', $ext_archive); ?>
			<?php  $link_ext_dir = str_replace(".zip", '', $link_ext_archive); ?>
			<td class="tc1"><?php if ( in_array( $ext_name, $installed_ext ) ) echo 'Yes'; else echo 'No'; ?></td>
			<td><?php echo  round( filesize ( $link_ext_archive )/1024, 1).' кб'; ?></td>
			<td class="tc3"><input type="submit" name="del_ext" value="<?php echo $lang_ext_man_loader['Delete'] ?>" /></td>
		</tr>
		</form>
<?php
	}
?>
				</tbody>
			</table>
		</div>
		
		
			<div id="info-censored-intro" class="ct-box">
				<p><?php echo $lang_ext_man_loader['More_Info'] .  $lang_ext_man_loader['author'] ?></p>
			</div>
		
		
		
	</div>
	

    
<?php
$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->

require FORUM_ROOT.'footer.php';